include:
  - project: "ayedocloudsolutions/backplane"
    file: "/.gitlab-ci.yml"

build.docker:
  needs:
    - job: build.docs
      artifacts: true
    - job: prepare
      artifacts: true

deploy.k8s:
  stage: deploy
  variables:
    RELEASE_NAMESPACE: default
    RELEASE_NAME: $CI_PROJECT_NAME
    RELEASE_ENVIRONMENT: production
    CHART_PATH: charts/$CI_PROJECT_NAME
  environment:
    name: $RELEASE_ENVIRONMENT
    url: https://docs.cloudstack.one
  script:
    - load-shipment
    - check-conditions $CI_JOB_NAME
    - helm upgrade --install --wait --namespace $RELEASE_NAMESPACE --create-namespace --set image.tag=$RELEASE_VERSION --version $RELEASE_VERSION $RELEASE_NAME $CHART_PATH
  rules:
    - exists:
        - "charts/docs"
      if: '$KUBECONFIG != "" && ($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH)'
      when: on_success
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: on_success
    - if: $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH
      when: never
  allow_failure: true
  needs:
    - job: release.code
      artifacts: true
    - job: release.docker
      artifacts: false
